<?php
/**
* Joomla Community Builder User Plugin: plug_cbhelloworld
* @version $Id$
* @package plug_simplesort
* @author Mikko
* @copyright (C) www.mikkosoft.fi
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL

*/

/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

global $mosConfig_absolute_path,$mosConfig_lang;
require_once ($mosConfig_absolute_path."/components/com_comprofiler/plugin/user/plug_cbadvancedsearch/cb_search.config.php");
require_once ($mosConfig_absolute_path."/components/com_comprofiler/plugin/user/plug_cbadvancedsearch/cb_search.class.php");

$_PLUGINS->registerFunction('onStartUsersList','doFilter','advancedsearch');
$_PLUGINS->registerFunction('onBeforeDisplayUsersList','getHeader','advancedsearch');

// Get the right language if it exists
if (file_exists($mosConfig_absolute_path . '/components/com_comprofiler/plugin/user/plug_cbadvancedsearch/languages/'.$mosConfig_lang.'.php')) {
	include ($mosConfig_absolute_path . '/components/com_comprofiler/plugin/user/plug_cbadvancedsearch/languages/'.$mosConfig_lang.'.php');
} else {
	include ($mosConfig_absolute_path . '/components/com_comprofiler/plugin/user/plug_cbadvancedsearch/languages/english.php');
}


class advancedsearch extends cbPluginHandler{
	
	function getHeader($row, $users, $columns, $allFields, $lists, $listid, $search, $option_itemid, $ui){
		global $mosConfig_debug,$mainframe;	
		
		$mainframe->addCustomHeadTag('<link rel="stylesheet" type="text/css" href="includes/js/tabs/tabpane.css">');
		

$searchtask = mosGetParam( $_REQUEST, 'searchtask');

$option=null; //ToDo: refactor out option

switch($searchtask){

case "advanced":
   $ret=$this->advanced($option);
   break;

case "simple":
   $ret=$this->simple($option);
   break;
   
default:
   $ret=$this->simple($option);
   break;
}
if($mosConfig_debug)
	$ret="<p>Advanced Search debug mode</p>".$ret;

				return array('header'=>$ret);

	}
function simple($option, $regErrorMSG=null ){
   global $database, $mosConfig_absolute_path;
   //Load the cb_as configuration

   $query = "SELECT f.* FROM #__comprofiler_fields f, #__cb_search_fields cb"
   . "\n WHERE f.fieldid=cb.fieldid"
   . "\n AND f.published=1 AND f.profile = 1 AND cb.search=1"
   . "\n ORDER BY cb.ordering, f.ordering";
        //echo $query;
   
   $database->setQuery( $query );
   $rowFields = $database->loadObjectList();
   $rowFieldValues=array();
   for ($i=0, $n=count( $rowFields ); $i < $n; $i++) {
      $k="";
      if ($regErrorMSG!==null && (isset($_POST[$rowFields[$i]->name]) || ($rowFields[$i]->type=='webaddress' && $rowFields[$i]->rows==2 && isset($_POST[$rowFields[$i]->name."Text"])))) {
         if (is_array($_POST[$rowFields[$i]->name])) $k = implode("|*|",$_POST[$rowFields[$i]->name]);
         else $k=$_POST[$rowFields[$i]->name];
         $k=htmlentities($k);
      } elseif ($regErrorMSG===null) {
         $_POST[$rowFields[$i]->name] = $rowFields[$i]->default;
      }
      $database->setQuery( "SELECT fieldtitle FROM #__comprofiler_field_values"
      . "\n WHERE fieldid = ".$rowFields[$i]->fieldid
      . "\n ORDER BY ordering" );
      $Values = $database->loadObjectList();
      $multi="";
      if($rowFields[$i]->type=='multiselect') $multi="multiple='multiple'";      
      if(count($Values) > 0) {
         if($rowFields[$i]->type=='radio') {
            $rowFieldValues['lst_'.$rowFields[$i]->name] = moscomprofilerHTML::radioListTable( $Values, $rowFields[$i]->name, 
               'class="inputbox" size="1" mosReq="'.$rowFields[$i]->required.'" mosLabel="'.getLangDefinition($rowFields[$i]->title).'"',
               'fieldtitle', 'fieldtitle', $k, $rowFields[$i]->cols, $rowFields[$i]->rows, $rowFields[$i]->size, $rowFields[$i]->required);
         } else {
            $ks=explode("|*|",$k);
            $k = array();
            foreach($ks as $kv) {
               $k[]->fieldtitle=$kv;
            }
            if($rowFields[$i]->type=='multicheckbox') {
               $rowFieldValues['lst_'.$rowFields[$i]->name] = moscomprofilerHTML::checkboxListTable( $Values, $rowFields[$i]->name."[]", 
                  'class="inputbox" size="'.$rowFields[$i]->size.'" '.$multi.' mosLabel="'.getLangDefinition($rowFields[$i]->title).'"', 
                  'fieldtitle', 'fieldtitle', $k, $rowFields[$i]->cols, $rowFields[$i]->rows, $rowFields[$i]->size, $rowFields[$i]->required);
            } else {
               $rowFieldValues['lst_'.$rowFields[$i]->name] = moscomprofilerHTML::selectList( $Values, $rowFields[$i]->name."[]", 
                  'class="inputbox" size="'.$rowFields[$i]->size.'" '.$multi.' mosReq="'.$rowFields[$i]->required.'" mosLabel="'.getLangDefinition($rowFields[$i]->title).'"', 
                  'fieldtitle', 'fieldtitle', $k);
            }
         }
      }
   }

   //We get the all fields names
   $row="";

   //Call up the html class
       return HTML_advancedsearch::simple($option, $rowFields, $rowFieldValues, $regErrorMSG);

}


function advanced($option, $regErrorMSG=null){
   global $database;
        //Load the cb_as configuration
 
   $query = "SELECT f.* FROM #__comprofiler_fields f, #__cb_search_fields cb"
   . "\n WHERE f.fieldid=cb.fieldid"
   . "\n AND f.published=1 AND f.profile = 1 AND cb.search=1"
   . "\n ORDER BY cb.ordering, f.ordering";
        //echo $query;
   
   $database->setQuery( $query );
   $rowFields = $database->loadObjectList();
   $rowFieldValues=array();
   for ($i=0, $n=count( $rowFields ); $i < $n; $i++) {
      $k="";
      if ($regErrorMSG!==null && (isset($_POST[$rowFields[$i]->name]) || ($rowFields[$i]->type=='webaddress' && $rowFields[$i]->rows==2 && isset($_POST[$rowFields[$i]->name."Text"])))) {
         if (is_array($_POST[$rowFields[$i]->name])) $k = implode("|*|",$_POST[$rowFields[$i]->name]);
         else $k=$_POST[$rowFields[$i]->name];
         $k=htmlentities($k);
      } elseif ($regErrorMSG===null) {
         $_POST[$rowFields[$i]->name] = $rowFields[$i]->default;
      }
      $database->setQuery( "SELECT fieldtitle FROM #__comprofiler_field_values"
      . "\n WHERE fieldid = ".$rowFields[$i]->fieldid
      . "\n ORDER BY ordering" );
      $Values = $database->loadObjectList();
      $multi="";
      if($rowFields[$i]->type=='multiselect') $multi="multiple='multiple'";
      if(count($Values) > 0) {
         if($rowFields[$i]->type=='radio') {
            $rowFieldValues['lst_'.$rowFields[$i]->name] = moscomprofilerHTML::radioListTable( $Values, $rowFields[$i]->name, 
               'class="inputbox" size="1" mosReq="'.$rowFields[$i]->required.'" mosLabel="'.getLangDefinition($rowFields[$i]->title).'"', 
               'fieldtitle', 'fieldtitle', $k, $rowFields[$i]->cols, $rowFields[$i]->rows, $rowFields[$i]->size, $rowFields[$i]->required);
         } else {
            $ks=explode("|*|",$k);
            $k = array();
            foreach($ks as $kv) {
               $k[]->fieldtitle=$kv;
            }
            if($rowFields[$i]->type=='multicheckbox') {
               $rowFieldValues['lst_'.$rowFields[$i]->name] = moscomprofilerHTML::checkboxListTable( $Values, $rowFields[$i]->name."[]",
                  'class="inputbox" size="'.$rowFields[$i]->size.'" '.$multi.' mosLabel="'.getLangDefinition($rowFields[$i]->title).'"',
                  'fieldtitle', 'fieldtitle', $k, $rowFields[$i]->cols, $rowFields[$i]->rows, $rowFields[$i]->size, $rowFields[$i]->required);
            } else {
               $rowFieldValues['lst_'.$rowFields[$i]->name] = moscomprofilerHTML::selectList( $Values, $rowFields[$i]->name."[]",
                  'class="inputbox" size="'.$rowFields[$i]->size.'" '.$multi.' mosReq="'.$rowFields[$i]->required.'" mosLabel="'.getLangDefinition($rowFields[$i]->title).'"',
                  'fieldtitle', 'fieldtitle', $k);
            }
         }
      }
   }

   //We get the all fields names
   $row="";
   //Call up the html class
       return HTML_advancedsearch::advanced($option, $rowFields, $rowFieldValues, $regErrorMSG);
}







	function doFilter($listid, $row, $search, $limitstart, $limit, $ui){
		global  $database,$mosConfig_absolute_path,$mosConfig_debug,$mainframe;

		if($mosConfig_debug)
   			echo("<p>Filterfields=$row->filterfields</p>");


		$task = mosGetParam( $_REQUEST, 'searchmode', '' );

			
		if (!isset( $_SESSION['session_userstate'] )){
			$_SESSION['session_userstate']=array();
		}	

		if($mosConfig_debug)
   			echo("<p>Search task=$task</p>");

		switch($task){
		case "expert":
   			$where=$this->doadvancedsearch();
   		break;

		case "simple":
   			$where=$this->simplesearch();
	   	break;

		case "advanced":
   			$where=$this->simplesearch2();
   		break;
		default:
			$where=$mainframe->getUserState("advancedsearch$listid");	
		}
		
		$mainframe->setUserState("advancedsearch$listid",$where);
	   
		if($mosConfig_debug)
   			echo("<p>Where=$where</p>");
		
   	    if(trim($row->filterfields)==''){
   	    	$row->filterfields = $where;   	    	
   	    }else{
			$row->filterfields = $row->filterfields ." AND " . $where;   	    	
   	    }

		
		if($mosConfig_debug)
   			echo("<p>Filterfields=$row->filterfields</p>");
	
	}


	function simplesearch(){
   global $database,$my,$ueConfig,$_POST,$_REQUEST, $mosConfig_absolute_path,$mosConfig_debug;

   //We load the CB Saech Config variables

   $searchword = mosGetParam( $_POST, 'searchword', '' );
   $searchword = $database->getEscaped( trim( $searchword ) );
   $phrase     = mosGetParam( $_POST, 'searchphrase', '' );
        
   $check_count = strlen($searchword);

   if($mosConfig_debug)
   		echo("<p>Search= $searchword</p>");
   		
   $where = "  (";
   $wheres  = array();
   switch ($phrase) {
      case 'exact':
         $wheres2 = array();
         //We get the custom fields
         $query_custom = "SELECT f.* FROM #__comprofiler_fields f"
            . "\n WHERE f.published=1 AND f.profile = 1 AND f.name<>'NA'"
            . "\n ORDER BY f.ordering";

         $database->setQuery( $query_custom );
         $customfield = $database->loadObjectList();
         for ($s=0, $n=count( $customfield ); $s < $n; $s++) {
            $customfields = &$customfield[$s];
               $wheres2[] = " LOWER(".cb_as::gettable($customfields->name).$customfields->name.") LIKE '%$searchword%'";
               
         }
         
         $where .= '(' . implode( ') OR (', $wheres2 ) . '))';
         break;

      case 'all':
      case 'any':
      default:
         $words   = explode( ' ', $searchword );
         $wheres = array();
         foreach ($words as $word) {
            $wheres2 = array();
            //We get the custom fields
            $query_custom = "SELECT f.* FROM #__comprofiler_fields f"
                  . "\n WHERE f.published=1 AND f.profile = 1 AND f.name<>'NA'"
                  . "\n ORDER BY f.ordering";
            $database->setQuery( $query_custom );
            $customfield = $database->loadObjectList();
            for ($s=0, $n=count( $customfield ); $s < $n; $s++) {
               $customfields = &$customfield[$s];
                  $wheres2[] = "LOWER(".cb_as::gettable($customfields->name).$customfields->name.") LIKE '%$word%'";

            }
            
            $wheres[]   = implode( ' OR ', $wheres2 );
         }
         
         $where .= '(' . implode( ($phrase == 'all' ? ') AND (' : ') OR ('), $wheres ) . '))';
         break;
   }
 	return $where;
}

function simplesearch2(){
   global $database,$my,$ueConfig,$_POST,$_REQUEST, $mosConfig_absolute_path;

   //We load the CB Saech Config variables
   require_once ($mosConfig_absolute_path."/components/com_comprofiler/plugin/user/plug_cbadvancedsearch/cb_search.config.php");

   $where = "  (";

//Generate the advanced search criteria

if(true){
   

$query2="";
$cbsa_fields = 0;
$cbsa_count = 0;
$cba_form_fields = 0;
$fieldcount =0;
$op_nr_1 = 1;
$def_op = " LIKE ";
$def_log =" AND "; 
$logical_operator = "";
$comparision_operator = "";
$jocker = "";
           
$form_fields = array_keys($_POST);

//echo sizeof($form_fields)."<br>";
   for ($i = 0; $i < sizeof($form_fields)-5; $i++) {
            $fieldcount ++;
            $logical = true;
            $comparision = true;
            
       $thisField = $form_fields[$i];
       $thisValue = mosGetParam( $_REQUEST, $thisField, '' );
       //echo "thisField:".$thisField." - thisValue:".$thisValue."<br>";

            //Define Logical Operator
            
            $pos = strpos($thisField, "searchoperator");
            
            if ($pos === 0 ){
               if ($thisValue == "="){
                  $comparision_operator = $thisValue;
                  $logical_operator = " ".$def_log." ";
                  $jocker = "";
               } elseif ($thisValue == "NOT"){
                  $comparision_operator = $thisValue." LIKE ";
                  $logical_operator = " ".$def_log." ";
                  $jocker = "%";
               } else {
                  $comparision_operator = $def_op;
                  $logical_operator = " ".$thisValue." ";
                  $jocker = "%";
               }  
            } 
            
            if ($fieldcount ==2){
          //We first check the if there is a value to search logical operator
          if (is_array($thisValue)){
            for ($j = 0; $j < sizeof($thisValue); $j++) {
               if ( strlen($thisValue[$j])>0 && $thisValue[$j] != "no_check" ){
                  $fieldvalue = "'".$jocker.$thisValue[$j].$jocker."'";
                  $pattern[0] = "\'%";
               $pattern[1] = "%\'"; 
               $pattern[2] = "\'"; 
               $replacement[0] = "'%";
               $replacement[1] = "%'";
               $replacement[2] = "'";
               $fieldvalue = str_replace($pattern, $replacement, $fieldvalue);

               if ($op_nr_1==1){
                     $query2 .= " ".$thisField." ".$comparision_operator." ".$fieldvalue;
                     $op_nr_1 ++;
               } else {
                  $query2 .= " ".$logical_operator.cb_as::gettable2($thisField).$thisField." ".$comparision_operator." ".$fieldvalue;
               }
               }
            }
          } else {
            if (strlen($thisValue)>0 ){
                     $fieldvalue = "'".$jocker.$thisValue.$jocker."'";
               $pattern[0] = "\'%";
            $pattern[1] = "%\'"; 
            $pattern[2] = "\'"; 
            $replacement[0] = "'%";
            $replacement[1] = "%'";
            $replacement[2] = "'";
                  $fieldvalue = str_replace($pattern, $replacement, $fieldvalue);

               if ($op_nr_1==1){
                     $query2 .= " ".$thisField." ".$comparision_operator." ".$fieldvalue;
                     $op_nr_1 ++;
               } else {
                     $query2 .= " ".$logical_operator.cb_as::gettable2($thisField).$thisField." ".$comparision_operator." ".$fieldvalue;
               }
            
            }
          }
     $fieldcount=0;
     }
     //echo $i.":".$fieldcount.". FieldName: ".$thisField." - FieldValue: ".$fieldvalue."<br>";
   }
}  
   
    if (strlen($query2) == 0) {
      $add_beg = "";
      $add_end = "";
   } else {
      $add_beg = $where;
      $add_end = " )";
   }

   $query2 = $add_beg.$query2.$add_end;

 return $query2;
}



function doadvancedsearch(){
   global $database,$my,$ueConfig,$_POST,$_REQUEST, $mosConfig_absolute_path;

   //We load the CB Saech Config variables
	require_once ($mosConfig_absolute_path."/components/com_comprofiler/plugin/user/plug_cbadvancedsearch/cb_search.config.php");
   //Generate the advanced search criteria

   if(true) {
      $query2="";
      $cbsa_fields = 0;
      $cbsa_count = 0;
      $cba_form_fields = 0;
      $fieldcount =0;
      $form_fields = array_keys($_POST);
      $lenadd = 0;

      for ($i = 0; $i < sizeof($form_fields)-4; $i++) {
               $fieldcount ++;

               //$logical_operator = " AND ";
               //$comparision_operator = " LIKE ";
               $logical = true;
               $comparision = true;

          $thisField = $form_fields[$i];
          $thisValue = mosGetParam( $_REQUEST, $thisField, '' );
          //echo $thisField.":";
          //echo $thisValue."<br>";

               //We get the value for the logical and comparision operators
               if (strpos($thisField,"_2" )){
                  $logical_operator = $thisValue;
                  $logical = false;
               }

               if (strpos($thisField, "_1")){
               $comparision_operator = $thisValue;
                  $comparision = false;
                  if ($thisValue == "IS NULL" || $thisValue == "IS NOT NULL"){
                     $lenadd = 1;
                  }
             }
               if ($fieldcount ==3){
             //We first check the if there is a value to search logical operator
             if (is_array($thisValue)){
               for ($j = 0; $j < sizeof($thisValue); $j++) {
                  if ( strlen($thisValue[$j]) + $lenadd >0 ){
                     $fieldvalue = str_replace("SEARCHWORD", $thisValue[$j], $comparision_operator);
                     $pattern[0] = "\'%";
                  $pattern[1] = "%\'";
                  $pattern[2] = "\'";
                  $replacement[0] = "'%";
                  $replacement[1] = "%'";
                  $replacement[2] = "'";
                  $fieldvalue = str_replace($pattern, $replacement, $fieldvalue);

                  if ($thisValue[$j] === "no_check"){
                     $query2 .="";
                  } else {
                     $query2 .= " ".$logical_operator." ".cb_as::gettable2($thisField).$thisField." ".$fieldvalue;
                  }
                   $lenadd = 0;
                  }
               }
             } else {
               if (strlen($thisValue) + $lenadd >0 ){
                        $fieldvalue = str_replace("SEARCHWORD", $thisValue, $comparision_operator);
                  $pattern[0] = "\'%";
               $pattern[1] = "%\'";
               $pattern[2] = "\'";
               $replacement[0] = "'%";
               $replacement[1] = "%'";
               $replacement[2] = "'";
               $fieldvalue = str_replace($pattern, $replacement, $fieldvalue);
               if ($thisValue != "no_check"){
                  $query2 .= " ".$logical_operator." ".cb_as::gettable2($thisField).$thisField." ".$fieldvalue;
               }
               $lenadd = 0;
               }
             }
        $fieldcount=0;
        }
      }
   }

        $where = $query2;
        //echo $where;
	return preg_replace("/^( |AND|OR)*/","",$where); //A little bit checkign to see if the query is valid. The code should be fixed so taht this would nto be needed.
	
}
 
}

//CB Advanced Search Component//
/**
* Front End Code
*@package cbadancedsearch
*@Copyright (C) 2006 Emptorum.com
*@ ALl Rights reserved
*@license  http://www.gnu.org/copyleft/gpl.html. GNU Public License
*@version 1.0
*/

//ensure this file is being included by a parent file
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );     

class HTML_advancedsearch {

function simple($option, $rowFields, $rowFieldValues, $regErrorMSG){
global $mosConfig_absolute_path, $mosConfig_live_site, $Itemid;

	require ($mosConfig_absolute_path."/components/com_comprofiler/plugin/user/plug_cbadvancedsearch/cb_search.config.php");



   $tmpl = & cb_as :: createTemplate();
   $tmpl->readTemplatesFromInput('cb_search.simple.tmpl.html');
   $tmpl->addVar('header', 'calendar', cb_as::cbCalendars(2) );
   //$tmpl->addVar('header', 'index', sefRelToAbs("index.php") );
   $ret='<table width="100%"" border="0"><tr><td>'.$tmpl->getParsedTemplate('header');
   if ( $cbsa_show_title ) {
      $tmpl->addVar('header_1', 'cb_as_title', _CB_AS_TITLE );
      $ret.=$tmpl->getParsedTemplate('header_1');
   }

   
   $searchphrase = mosGetParam( $_REQUEST, 'searchphrase', 'any' );
   $searchphrases = array();

   $phrase = new stdClass();
   $phrase->value = 'any';
   $phrase->text = _SEARCH_ANYWORDS;
   $searchphrases[] = $phrase;

   $phrase = new stdClass();
   $phrase->value = 'all';
   $phrase->text = _SEARCH_ALLWORDS;
   $searchphrases[] = $phrase;

   $phrase = new stdClass();
   $phrase->value = 'exact';
   $phrase->text = _SEARCH_PHRASE;
   $searchphrases[] = $phrase;

   $lists['searchphrase']= mosHTML::radioList( $searchphrases, 'searchphrase', '', $searchphrase );
   $image_url = $mosConfig_live_site."/components/com_cb_search/images/search.gif";

   $tabs = new cbTabs(true,1);
   $ret.=$tabs->startPane("searchPane");

	$spooftag=cbGetSpoofInputTag();
	
		if ( $cbsa_allow_search_1 ){
      $ret.=$tabs->startTab("searchPane",_CB_AS_SHOW_SIMPLE,"simple-page");
      $tmpl->addVar('search_1', 'cb_as_search_title_1', _CB_AS_SEARCH_TITLE_1 );
      $tmpl->addVar('search_1', 'cb_as_search_gif', $image_url );
      $tmpl->addVar('search_1', 'cb_as_button', _CB_AS_BUTTON );
      $tmpl->addVar('search_1', 'prompt_keyword', _CB_AS_ALL_FIELDS );
      $tmpl->addVar('search_1', 'list', $lists['searchphrase'] );
      $tmpl->addVar('search_1', 'spooftag', $spooftag);

      $ret.=$tmpl->getParsedTemplate('search_1');
      $ret.=$tabs->endTab();
   }  
   //$ret.=$tmpl->getParsedTemplate('search_1_footer');
   
   if ( $cbsa_allow_search_2 ){
      $ret.=$tabs->startTab("searchPane",_CB_AS_SHOW_ADVANCED,"advanced-page");
      $tmpl->addVar('search_2', 'cb_as_search_title_2', _CB_AS_SEARCH_TITLE_2 );
      $tmpl->addVar('search_2', 'spooftag', $spooftag);
      $ret.=$tmpl->getParsedTemplate('search_2');

      $pfields='';
      $title='';
      $searchoperators='';
      $searchoperators2='';
      for($i=0, $n=count( $rowFields ); $i < $n; $i++) {
         $colspan = 3;
         $pfields='';
         if($rowFields[$i]->type=='delimiter') {
            $tmpl->addVar('search_2_delimiter', 'colspan', $colspan );
            $tmpl->addVar('search_2_delimiter', 'title', unHtmlspecialchars(getLangDefinition($rowFields[$i]->title)) );
            $ret.=$tmpl->getParsedTemplate('search_2_delimiter');
         } else {
            if(getLangDefinition($rowFields[$i]->title)!="") {
               $title = getLangDefinition($rowFields[$i]->title);
               $colspan=1;
            }
            if($regErrorMSG!==null && isset($_POST[$rowFields[$i]->name])) {
               if (!is_array($_POST[$rowFields[$i]->name])) $oValue = htmlentities($_POST[$rowFields[$i]->name]);
               if($rowFields[$i]->type=='date') $oValue=dateConverter($oValue,$ueConfig['date_format'],'Y-m-d');
               if($rowFields[$i]->type=='webaddress' && $rowFields[$i]->rows==2) $oValue=$oValue."|*|".$_POST[$rowFields[$i]->name."Text"];
            } else $oValue = "";
            if(!ISSET($rowFields[$i]->id)) $rowFields[$i]->id="";
            if(!ISSET($rowFieldValues['lst_'.$rowFields[$i]->name])) $rowFieldValues['lst_'.$rowFields[$i]->name]="";
            if ($rowFields[$i]->type=='multicheckbox' || $rowFields[$i]->type=='multiselect' || $rowFields[$i]->type=='radio'){
               $pfields = "<input readonly type=\"hidden\" name=\"".$rowFields[$i]->name."[]\" value=\"no_check\" checked />";
            }
            $pfields .= cb_as::getFieldEntry(1,$calendars,$rowFields[$i]->type,$rowFields[$i]->name,$rowFields[$i]->description,$rowFields[$i]->title,$oValue,$rowFields[$i]->required,$rowFields[$i]->title,$rowFields[$i]->id,$rowFields[$i]->size, $rowFields[$i]->maxlength, $rowFields[$i]->cols, $rowFields[$i]->rows,$rowFields[$i]->profile,$rowFieldValues['lst_'.$rowFields[$i]->name],$rowFields[$i]->readonly);
         }
                        
         //we get the default value for the searchoperator
         switch ($cbsa_logical_default){
            case "0":
               $logical_default = "=";
               break;
            case "1":
               $logical_default = "AND";
               break;         
            case "2":
               $logical_default = "OR";
               break;
            case "3":
               $logical_default = "NOT";
               break;
            default:
               $logical_default = "AND";
               break;
         }                       
         
         $searchoperator = mosGetParam( $_REQUEST, 'searchoperator', $logical_default );
         $searchoperators = array();
                        
                        $search_op_count = 0;
                        $search_op_count2 = $cbsa_logical_equal + $cbsa_logical_and + $cbsa_logical_or + $cbsa_logical_not;
                        $op_tag_attribs= '';
                        $op_hidden = '';
         if ($cbsa_logical_equal==1){
            $operator = new stdClass();
            $operator->value = '=';
            $operator->text = _CB_AS_OPERATORS_EQUAL;
            $searchoperators[] = $operator;
            $search_op_count++;
            $op_hidden = "radio";
         } 
         if ($cbsa_logical_and==1){
            $operator = new stdClass();
            $operator->value = 'AND';
            $operator->text = _CB_AS_OPERATORS_AND;
            $searchoperators[] = $operator;
            $search_op_count++;
            $op_hidden = "radio";
         } 
         if ($cbsa_logical_or==1){
            $operator = new stdClass();
            $operator->value = 'OR';
            $operator->text = _CB_AS_OPERATORS_OR;
            $searchoperators[] = $operator;
            $search_op_count++;
            $op_hidden = "radio";
         } 
         if ($cbsa_logical_not==1){
            $operator = new stdClass();
            $operator->value = 'NOT';
            $operator->text = _CB_AS_OPERATORS_NOT;
            $searchoperators[] = $operator;
            $search_op_count++;
            $op_hidden = "radio";
         }
                        
         if ($search_op_count==0){
            $operator = new stdClass();
            $operator->value = 'AND';
            $operator->text = _CB_AS_OPERATORS_AND;
            $searchoperators[] = $operator;  

            $searchoperator = "AND";
            $op_tag_attribs = 'readonly checked';
            $op_hidden = "hidden";
         } elseif ( $search_op_count==1 && $search_op_count2 == 1 ){
                 $op_hidden = "hidden";
         }
         
         $lists['searchoperator']= cb_as::radioList( $searchoperators, 'searchoperator'.$i, $op_tag_attribs, $searchoperator, $op_hidden );

         $tmpl->addVar('search_2_list', 'title', $title );
         $tmpl->addVar('search_2_list', 'colspan', $colspan );
         $tmpl->addVar('search_2_list', 'field', $pfields); 
         $tmpl->addVar('search_2_list', 'operators', $lists['searchoperator'] );
         $ret.=$tmpl->getParsedTemplate('search_2_list');
         $tmpl->clearTemplate('search_2_list');
      }
      $tmpl->addVar('search_2_list_footer', 'cb_as_search_gif', $image_url );
      $tmpl->addVar('search_2_list_footer', 'cb_as_button', _CB_AS_BUTTON );
      $tmpl->addVar('search_2_list_footer', 'spooftag', $spooftag);
      $ret.=$tmpl->getParsedTemplate('search_2_list_footer');
      $ret.=$tabs->endTab();
   }
         
   if($cbsa_allow_adv_search){
   	 $lid=mosGetParam($_REQUEST,'listid',-1);
   	 if($lid!=-1)
   	 	$listid="&listid=$lid";
   	 else 
   	 	$listid="";
   	 	
   $ret.=$tabs->startTab("searchPane",_CB_AS_SHOW_ADVANCED2,"advanced2-page");
      $cb_sa_adv_url = sefRelToAbs("index.php?option=com_comprofiler&task=userslist".$listid."&searchtask=advanced&itemid=".mosGetParam($_GET,'itemid',mosGetParam($_GET,'Itemid',1)));
      $cb_sa_adv_url = ampReplace($cb_sa_adv_url);

      $tmpl->addVar('allow', 'allow_url', $cb_sa_adv_url );
      $tmpl->addVar('allow', 'allow_text', _CB_AS_ALLOW_ADV_USER );
      $tmpl->addVar('allow', 'cb_as_search_title_3', _CB_AS_SEARCH_TITLE_3 );

      $ret.=$tmpl->getParsedTemplate('allow');
      $ret.=$tabs->endTab();
   }


//   $tmpl->addVar('footer', 'cb_as_button', _CB_AS_BUTTON );
//   $ret.=$tmpl->getParsedTemplate('footer');
	$ret.=$tabs->endPane();
	return $ret."</td></tr></table>";
//End of Function
}



function advanced($option, $rowFields, $rowFieldValues, $regErrorMSG){
global $mosConfig_absolute_path, $mosConfig_live_site, $Itemid;
require ($mosConfig_absolute_path."/components/com_comprofiler/plugin/user/plug_cbadvancedsearch/cb_search.config.php"); 

$ret= cb_as::cbCalendars(2);

$ret.='<form method="post" id="adminForm" name="adminForm">
<table cellpadding="5" cellspacing="0" border="0" width="98%" class="contentpane" id="registrationTable">';

if ( $cbsa_show_title ) {
$ret.='<tr>
      <td colspan="3" width="100%" class="componentheading">'. _CB_AS_TITLE .'</td>
    </tr>';

}

$pfields='';
$searchoperators='';
$searchoperators2='';
for($i=0, $n=count( $rowFields ); $i < $n; $i++) {
   //echo "Anzahl Felder:".count($rowFields).":".$rowFields[$i]->type.":".$rowFields[$i]->name.":".$rowFields[$i]->description."<br>";
   //echo "Anzahl Werte:".count($rowFieldValues).":"."<br>";

   $pfields .= "\t\t<tr>\n";
   $colspan = 5;
   if($rowFields[$i]->type=='delimiter') {
      $pfields .= "\t\t\t<td colspan=\"".$colspan."\" class=\"delimiterCell\">". unHtmlspecialchars(getLangDefinition($rowFields[$i]->title)) ."</td>\n";
      if ($rowFields[$i]->description) $pfields .= "\t\t\t</tr><tr><td colspan=\"".$colspan."\" class=\"descriptionCell\">". unHtmlspecialchars(getLangDefinition($rowFields[$i]->description)) ."</td>\n";
   } else {
      if(getLangDefinition($rowFields[$i]->title)!="") {
         $pfields .= "\t\t\t<td align=\"right\">"
             . cb_as::operator2($i, 2)
             . "</td>";

         $pfields .= "\t\t\t<td align=\"right\">"
             . getLangDefinition($rowFields[$i]->title)
             . ":</td>";
         $colspan=1;
      }
      if($regErrorMSG!==null && isset($_POST[$rowFields[$i]->name])) {
         if (!is_array($_POST[$rowFields[$i]->name])) $oValue = htmlentities($_POST[$rowFields[$i]->name]);
         if($rowFields[$i]->type=='date') $oValue=dateConverter($oValue,$ueConfig['date_format'],'Y-m-d');
         if($rowFields[$i]->type=='webaddress' && $rowFields[$i]->rows==2) $oValue=$oValue."|*|".$_POST[$rowFields[$i]->name."Text"];
      } else $oValue = "";
      if(!ISSET($rowFields[$i]->id)) $rowFields[$i]->id="";
      if(!ISSET($rowFieldValues['lst_'.$rowFields[$i]->name])) $rowFieldValues['lst_'.$rowFields[$i]->name]="";
      $pfields .= "\t\t\t<td colspan=\"".$colspan."\" class=\"fieldCell\">"
          . cb_as::operator2($i, 1)
          ."</td><td>\n"
          . cb_as::getFieldEntry(1,$calendars,$rowFields[$i]->type,$rowFields[$i]->name,$rowFields[$i]->description,$rowFields[$i]->title,$oValue,$rowFields[$i]->required,$rowFields[$i]->title,$rowFields[$i]->id,$rowFields[$i]->size, $rowFields[$i]->maxlength, $rowFields[$i]->cols, $rowFields[$i]->rows,$rowFields[$i]->profile,$rowFieldValues['lst_'.$rowFields[$i]->name],$rowFields[$i]->readonly);
      if ($rowFields[$i]->type=='multicheckbox' || $rowFields[$i]->type=='multiselect' || $rowFields[$i]->type=='radio'){
               $pfields .= "<input readonly type=\"hidden\" name=\"".$rowFields[$i]->name."[]\" value=\"no_check\" checked />";
      }
      $pfields .= "</td>\n";
   }
   $pfields .= "\t\t</tr>\n";
}
$ret.= $pfields;

$ret.='<tr>
      <td colspan="3">'.
         cb_as::operator2($i, 2).
      '</td>
    </tr>
    <tr>
      <td colspan="2">
  <input type="hidden" name="id" value="0" />
  <input type="hidden" name="searchmode" value="expert" />
  <input type="hidden" name="gid" value="0" />
  <input type="submit" value="'. _CB_AS_BUTTON .'" class="button" />
  '.cbGetSpoofInputTag().'
  </td>
      </tr>
</table>
</form>';

     $lid=mosGetParam($_REQUEST,'listid',-1);
   	 if($lid!=-1)
   	 	$listid="&listid=$lid";
   	 else 
   	 	$listid="";

$ret.='<p><a href="'.
"index.php?option=com_comprofiler&task=userslist".$listid."&searchtask=simple&itemid=".mosGetParam($_GET,'itemid',mosGetParam($_GET,'Itemid',1)).
'">Back to simple mode</a></p>';
     
return $ret;

//End of Function
}
}

?>